/* 
 Теоретичні питання
 1. Як можна сторити функцію та як ми можемо її викликати? 
 2. Що таке оператор return в JavaScript? Як його використовувати в функціях?
 3. Що таке параметри та аргументи в функіях та в яких випадках вони використовуються?
 4. Як передати функцію аргументом в іншу функцію? 

 Практичні завдання
 1. Напишіть функцію, яка повертає частку двох чисел. Виведіть результат роботи функції в консоль.
 
 2. Завдання: Реалізувати функцію, яка виконуватиме математичні операції з введеними користувачем числами.

Технічні вимоги:
- Отримати за допомогою модального вікна браузера два числа. Провалідувати отримані значення(перевірити, що отримано числа). Якщо користувач ввів не число, запитувати до тих пір, поки не введе число
- Отримати за допомогою модального вікна браузера математичну операцію, яку потрібно виконати. Сюди може бути введено +, -, *, /. Провалідувати отримане значення. Якщо користувач ввів не передбачене значення, вивести alert('Такої операції не існує').
- Створити функцію, в яку передати два значення та операцію.
- Вивести у консоль результат виконання функції.

3. Опціонально. Завдання: 
Реалізувати функцію підрахунку факторіалу числа. 
Технічні вимоги:
- Отримати за допомогою модального вікна браузера число, яке введе користувач.
- За допомогою функції порахувати факторіал числа, яке ввів користувач і вивести його на екран.
- Використовувати синтаксис ES6 для роботи зі змінними та функціями.
*/

/* 

Теория 

1) Функцию можно создать несколькими способами function declaration - function name(){}, function expression - const name = function(){};
Вызвать функцию можно по ее имени, например - name();

2) Оператор return возвращает результат работы функции, используется например таким образом function sum(a,b) {return a + b}

3) Параметр это переменные которые указываются при ее создании, используются они внутри самой функции

4) function greet(name) {
    console.log(`Hello, ${name}`);
}

function callWriting(func, arg){
    func(arg);
}

callWriting(greet, 'Dmytro')

*/

// практика

// 1
/* 
let firstNum = prompt('enter your first num', '');
let secondNum = prompt('enter your second num', '');


function calc (firstNum, secondNum) {
    return firstNum / secondNum;
}

const result = calc(firstNum, secondNum);

console.log(`Результат деления ${firstNum} на ${secondNum} дает результат: ${result}`) 
 */

// 2

let firstNum = +prompt('Введите первое число', '');

while(isNaN(firstNum) || firstNum === 0) {
        firstNum = +prompt('Вы указали не число, попробуйте повторить', '');

}

let operator = prompt('Введите операцию которую хотите выполнить +, -, /, *', '');

while(operator !== '+' && operator !== '-' && operator !== '*' && operator !== '/') {
    operator = prompt('Такой операции не сущевствует, попробуйте снова с +, -, /, *', '');
}


let secondNum = +prompt('Введите второе число', '');

while(isNaN(secondNum) || secondNum === 0) {
    secondNum = +prompt('Вы указали не число, попробуйте повторить', '');
}

function calculator(firstNum, secondNum, operator) {
    switch(operator) {
        case '+': 
            return firstNum + secondNum;
        case '-': 
            return firstNum - secondNum;
        case '*':
            return firstNum * secondNum;
        case '/':
            return firstNum / secondNum;
        default: 
            return 'Такой операции не сущевствует';
    }
}
const res = calculator(firstNum, secondNum, operator);

alert(res);


